﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=7.31
@EndOfDesignText@
'v1.00 Fixed by MAGMA for more CLV's transfer list items...
Sub Class_Globals
	Private xui As XUI
	Private fx As JFX
	Private list(100) As CustomListView 'set a hundred.... not know if need so... if other way (can't think now)
	Private howlist As Int
	Private PressedColor As Int
End Sub

Public Sub Initialize (aa As List) ',clv As CustomListView
	howlist=aa.Size
	For k=0 To howlist-1
		list(k) = aa.Get(k)
		PressedColor = list(k).PressedColor
	Next
End Sub

Public Sub Resize
	For k=0 To howlist-1
		For i = 0 To list(k).Size - 1
			Dim p As B4XView = list(k).GetPanel(i)
			Dim v As B4XView = p.GetView(p.NumberOfViews - 1)
			If v Is Label And v.Tag = list(k) Then
				v.Left = p.Width - 32dip
			End If
		Next
	Next 
End Sub

Public Sub RemoveDragButtons
	For k=0 To howlist-1
		For i = 0 To list(k).Size - 1
			Dim p As B4XView = list(k).GetPanel(i)
			If IsLastViewADragLabel(p) Then
				p.GetView(p.NumberOfViews - 1).RemoveViewFromParent
				p.GetView(p.NumberOfViews - 1).RemoveViewFromParent
				p.GetView(p.NumberOfViews - 1).RemoveViewFromParent
			End If
		Next
	Next
	list(k).PressedColor = PressedColor
End Sub

Private Sub IsLastViewADragLabel (p As B4XView) As Boolean
	For k=0 To howlist-1
		If p.NumberOfViews > 0 Then
			Dim v As B4XView = p.GetView(p.NumberOfViews - 1)
			Return v Is Label And v.Tag = list(k)
		End If
	Next
	Return False
End Sub

Public Sub AddDragButtons
	For k=0 To howlist-1
		list(k).PressedColor = xui.Color_Transparent
		Dim fnt As B4XFont = xui.CreateMaterialIcons(30)
		For i = 0 To list(k).Size - 1
			Dim p As B4XView = list(k).GetPanel(i)
			If IsLastViewADragLabel(p) = False Then
				Dim lbl As Label
				lbl.Initialize("prev")
				lbl.MouseCursor = fx.Cursors.HAND
				Dim xlbl As B4XView = lbl
				xlbl.Font = fnt
				xlbl.Text = Chr(0xE314)
				xlbl.TextColor = list(k).DefaultTextColor
				xlbl.Tag = k
				p.AddView(xlbl, p.Width - 92dip, p.Height / 2 - 15dip, 30dip, 30dip)
				
				Dim lbl2 As Label
				lbl2.Initialize("drag")
				lbl2.MouseCursor = fx.Cursors.HAND
				Dim xlbl2 As B4XView = lbl2
				xlbl2.Font = fnt
				xlbl2.Text = Chr(0xE25D)
				xlbl2.TextColor = list(k).DefaultTextColor
				xlbl2.Tag = list(k)
				p.AddView(xlbl2, p.Width - 62dip, p.Height / 2 - 15dip, 30dip, 30dip)
				
				Dim lbl3 As Label
				lbl3.Initialize("nex")
				lbl3.MouseCursor = fx.Cursors.HAND
				Dim xlbl3 As B4XView = lbl3
				xlbl3.Font = fnt
				xlbl3.Text = Chr(0xE315)
				xlbl3.TextColor = list(k).DefaultTextColor
				xlbl3.Tag = k
				p.AddView(xlbl3, p.Width - 32dip, p.Height / 2 - 15dip, 30dip, 30dip)

			End If
		Next
	Next 
End Sub

Private Sub Drag_MousePressed (EventData As MouseEvent)
	Dim lbl As B4XView = Sender
		
		Dim listk As CustomListView = lbl.Tag
		Dim pnl As B4XView = listk.GetPanel(listk.GetItemFromView(lbl)).Parent
		pnl.GetView(0).SetColorAndBorder(xui.Color_Transparent, 3dip, 0xFF503ACD, 0)
		Dim ListStartY As Int = EventData.Y + lbl.Top + pnl.Top
		pnl.BringToFront
		Dim Top As Int = pnl.Top
		Do While True
			Wait For (lbl) Drag_MouseDragged (EventData As MouseEvent)
			If pnl.Top < listk.sv.ScrollViewOffsetY Then
				listk.sv.ScrollViewOffsetY = Max(0, listk.sv.ScrollViewOffsetY - 10dip)
			Else If listk.sv.ScrollViewOffsetY + listk.sv.Height < pnl.Top + pnl.Height Then
				listk.sv.ScrollViewOffsetY = listk.sv.ScrollViewOffsetY + 10dip
			End If
			Dim ListY As Int = EventData.Y + lbl.Top + pnl.Top
			Dim delta As Int = ListY - ListStartY
			pnl.Top = Top + delta
		Loop

End Sub

Private Sub Drag_MouseReleased (EventData As MouseEvent)
	Dim lbl As B4XView = Sender


		Dim listk As CustomListView = lbl.Tag
		Dim index As Int = listk.GetItemFromView(lbl)
		Dim pnl As B4XView = listk.GetPanel(index).Parent
		Dim Offset As Int = pnl.Top + pnl.Height / 2
		Dim NewIndex As Int = listk.FindIndexFromOffset(Offset)
		Dim UnderlyingItem As CLVItem = listk.GetRawListItem(NewIndex)
		If Offset - UnderlyingItem.Offset > UnderlyingItem.Size / 2 Then NewIndex = NewIndex + 1
		Dim ActualItem As B4XView = pnl.GetView(0)
		ActualItem.SetColorAndBorder(pnl.Color, 0dip, xui.Color_Black, 0)
		Dim RawItem As CLVItem = listk.GetRawListItem(index)
		listk.RemoveAt(index)
		If NewIndex > index Then NewIndex = NewIndex - 1
		NewIndex = Max(0, Min(listk.Size, NewIndex))
		listk.InsertAt(NewIndex, ActualItem, RawItem.Value)
		listk.GetRawListItem(NewIndex).TextItem = RawItem.TextItem

End Sub

Private Sub prev_MouseClicked (EventData As MouseEvent)
	Dim lbl As B4XView = Sender
	Dim moveat As Int
	If lbl.Tag.As(Int)=0 Then moveat=howlist-1 Else moveat=lbl.Tag.As(Int)-1
	Log(lbl.Tag & " " & moveat)
	Dim index As Int = list(lbl.Tag.As(Int)).GetItemFromView(lbl)
	Dim pnl As B4XView = list(lbl.Tag.As(Int)).GetPanel(index).Parent
	Dim ActualItem As B4XView = pnl.GetView(0)
	ActualItem.SetColorAndBorder(pnl.Color, 0dip, xui.Color_Black, 0)
	Dim RawItem As CLVItem = list(lbl.tag.As(Int)).GetRawListItem(index)
	list(moveat).add(ActualItem, RawItem.Value)
	'list(moveat).GetRawListItem(list(moveat).size-1).TextItem = RawItem.TextItem
	list(lbl.Tag.As(Int)).RemoveAt(index)
	
	'Here need to change the nex and prev tag with the new CLV index
	'not having the time to search how... at least for today
	
End Sub

Private Sub nex_MouseClicked (EventData As MouseEvent)
	Dim lbl As B4XView = Sender
	Dim moveat As Int
	If lbl.Tag.As(Int)=howlist-1 Then moveat=0 Else moveat=lbl.Tag.As(Int)+1
	Log(lbl.Tag & " " & moveat)
	Dim index As Int = list(lbl.Tag.As(Int)).GetItemFromView(lbl)
	Dim pnl As B4XView = list(lbl.Tag.As(Int)).GetPanel(index).Parent
	Dim ActualItem As B4XView = pnl.GetView(0)
	ActualItem.SetColorAndBorder(pnl.Color, 0dip, xui.Color_Black, 0)
	Dim RawItem As CLVItem = list(lbl.tag.As(Int)).GetRawListItem(index)
	list(moveat).Add(ActualItem, RawItem.Value)
	'list(moveat).GetRawListItem(list(moveat).size-1).TextItem = RawItem.TextItem
	list(lbl.Tag.As(Int)).RemoveAt(index)
	
	'Here need to change the nex and prev tag with the new CLV index
	'not having the time to search how... at least for today
	
End Sub